
Blockly.Blocks['grille_set'] = {
  init: function() {
    this.jsonInit({
      "message0": Blockly.Msg.GRILLE_SET_TITLE,
      "args0": [
        {
          "type": "input_value",
          "name": "x",
          "check": "Number"
        },
        {
          "type": "input_value",
          "name": "y",
          "check": "Number"
        },
        {
          "type": "input_value",
          "name": "legende",
          "check": "Number"
        }
      ],
      "previousStatement": null,
      "nextStatement": null,
      "colour": Blockly.Blocks.variables.HUE,
      "helpUrl": Blockly.Msg.GRILLE_SET_HELPURL
    });
    var thisBlock = this;
	this.setInputsInline(true);
    this.getInput('x').setAlign(Blockly.ALIGN_RIGHT);
    this.getInput('y').setAlign(Blockly.ALIGN_RIGHT);
    this.getInput('legende').setAlign(Blockly.ALIGN_RIGHT);
    this.setTooltip(function() {
		return Blockly.Msg.GRILLE_SET_TOOLTIP;
    });
  }
};

Blockly.Blocks['grille_get'] = {
  init: function() {
    this.jsonInit({
      "message0": Blockly.Msg.GRILLE_GET_TITLE,
      "args0": [
        {
          "type": "input_value",
          "name": "x",
          "check": "Number"
        },
        {
          "type": "input_value",
          "name": "y",
          "check": "Number"
        }
      ],
      "output": 'Number',
      "colour": Blockly.Blocks.variables.HUE,
      "helpUrl": Blockly.Msg.GRILLE_GET_HELPURL
    });
    var thisBlock = this;
	this.setInputsInline(true);
    this.getInput('x').setAlign(Blockly.ALIGN_RIGHT);
    this.getInput('y').setAlign(Blockly.ALIGN_RIGHT);
    this.setTooltip(function() {
		return Blockly.Msg.GRILLE_GET_TOOLTIP;
    });
  }
};

Blockly.Blocks['grille_setrange'] = {
  init: function() {
	var dropdown = new Blockly.FieldDropdown([
		['A', '0'], ['B', '1'], ['C', '2'], ['D', '3'], ['E', '4'],
		['F', '5'], ['G', '6'], ['H', '7'], ['I', '8'], ['J', '9']
	]);
	var variable = new Blockly.FieldVariable(Blockly.Msg.VARIABLES_DEFAULT_NAME);
	var x = new Blockly.FieldTextInput();
	this.appendDummyInput()
		.appendField('fixer');
    this.appendValueInput('x')
        .setCheck('Number')
		.appendField(dropdown, 'y')
		;
	this.appendDummyInput()
		.appendField('à');
    this.appendValueInput('legende')
        .setCheck(['Number','String'])
	this.setHelpUrl('');
	this.setPreviousStatement(true);
	this.setNextStatement(true);
	this.setColour(Blockly.Blocks.variables.HUE);
    this.setTooltip(function() {
		return Blockly.Msg.GRILLE_SETRANGE_TOOLTIP;
    });
  }
};

Blockly.Blocks['grille_getrange'] = {
  init: function() {
	var dropdown = new Blockly.FieldDropdown([
		['A', '0'], ['B', '1'], ['C', '2'], ['D', '3'], ['E', '4'],
		['F', '5'], ['G', '6'], ['H', '7'], ['I', '8'], ['J', '9']
	]);
	var variable = new Blockly.FieldVariable(Blockly.Msg.VARIABLES_DEFAULT_NAME);
	var x = new Blockly.FieldTextInput();
	this.appendDummyInput()
		.appendField('');
    this.appendValueInput('x')
        .setCheck('Number')
		.appendField(dropdown, 'y')
		;
	this.setHelpUrl('');
	this.setInputsInline(true);
	this.setOutput(['Number','String']);
	this.setColour(Blockly.Blocks.variables.HUE);
    this.setTooltip(function() {
		return Blockly.Msg.GRILLE_SETRANGE_TOOLTIP;
    });
  }
};

Blockly.Blocks['text_confirm'] = {
  init: function() {
    this.jsonInit({
      "message0": Blockly.Msg.TEXT_CONFIRM_TITLE,
      "args0": [
        {
          "type": "input_value",
          "name": "VALUE",
          "check": ['String', 'Array']
        }
      ],
      "output": 'Boolean',
      "colour": Blockly.Blocks.texts.HUE,
      "tooltip": Blockly.Msg.TEXT_CONFIRM_TOOLTIP,
      "helpUrl": Blockly.Msg.TEXT_CONFIRM_HELPURL
    });
  }
};
