
Blockly.JavaScript['grille_set'] = function(block) {
  var argument0 = Blockly.JavaScript.valueToCode(block, 'x',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  var argument1 = Blockly.JavaScript.valueToCode(block, 'y',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  var argument2 = Blockly.JavaScript.valueToCode(block, 'legende',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  return 'grille_set(' + argument0 + ',' + argument1 + ',' + argument2 + ');\n';
};

Blockly.JavaScript['grille_get'] = function(block) {
  var argument0 = Blockly.JavaScript.valueToCode(block, 'x',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  var argument1 = Blockly.JavaScript.valueToCode(block, 'y',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  code = 'grille_get(' + argument0 + ',' + argument1 + ')';
  return [code, Blockly.JavaScript.ORDER_FUNCTION_CALL];
};

Blockly.JavaScript['grille_setrange'] = function(block) {
  var argument0 = Blockly.JavaScript.valueToCode(block, 'x',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  var argument1 = block.getFieldValue('y');
  var argument2 = Blockly.JavaScript.valueToCode(block, 'legende',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  return 'grille_set(' + argument0 + ',' + argument1 + ',' + argument2 + ');\n';
};

Blockly.JavaScript['grille_getrange'] = function(block) {
  var argument0 = Blockly.JavaScript.valueToCode(block, 'x',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  var argument1 = block.getFieldValue('y');
  code = 'grille_get(' + argument0 + ',' + argument1 + ')';
  return [code, Blockly.JavaScript.ORDER_FUNCTION_CALL];
};

Blockly.JavaScript['text_confirm'] = function(block) {
  // Is the string null?
  var argument0 = Blockly.JavaScript.valueToCode(block, 'VALUE',
      Blockly.JavaScript.ORDER_MEMBER) || '\'\'';
  return ['confirm('+argument0+')', Blockly.JavaScript.ORDER_LOGICAL];
};

// ameliore la traduction quand la borne sup d'un Pour est une variable
Blockly.JavaScript['controls_for'] = function(block) {
  // For loop.
  var variable0 = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  var argument0 = Blockly.JavaScript.valueToCode(block, 'FROM',
      Blockly.JavaScript.ORDER_ASSIGNMENT) || '0';
  var argument1 = Blockly.JavaScript.valueToCode(block, 'TO',
      Blockly.JavaScript.ORDER_ASSIGNMENT) || '0';
  var increment = Blockly.JavaScript.valueToCode(block, 'BY',
      Blockly.JavaScript.ORDER_ASSIGNMENT) || '1';
  var branch = Blockly.JavaScript.statementToCode(block, 'DO');
  branch = Blockly.JavaScript.addLoopTrap(branch, block.id);
  var code;
  if (Blockly.isNumber(increment)) {
    // All arguments are simple numbers.
    var up = parseFloat(increment) >= 0;
    code = 'for (' + variable0 + ' = ' + argument0 + '; ' +
        variable0 + (up ? ' <= ' : ' >= ') + argument1 + '; ' +
        variable0;
    var step = Math.abs(parseFloat(increment));
    if (step == 1) {
      code += up ? '++' : '--';
    } else {
      code += (up ? ' += ' : ' -= ') + step;
    }
    code += ') {\n' + branch + '}\n';
  } else {
    var up = true;
    code = 'for (' + variable0 + ' = ' + argument0 + '; ' +
        variable0 + (up ? ' <= ' : ' >= ') + argument1 + '; ' +
        variable0;
    code += (up ? ' += ' : ' -= ') + increment;
    code += ') {\n' + branch + '}\n';
  }
  return code;
};

///////////////////////////////////////////////////////////////////////
// redéfinitions et calcul symbolique
///////////////////////////////////////////////////////////////////////

function set_formule(varName, expression) {
	var nom = varName;
	var leg = expression;
	var ind, k;
	// on interprète l'expression
	for(k=0;k<Blockly.JavaScript.xcasVars.length;k++) {
		nom = Blockly.JavaScript.xcasVars[k];
		ind = Blockly.JavaScript.xcasIndices[k];
		leg = leg.split(nom).join(nom.substring(1)+ind);
	}
	// on interprète le nom de la variable
	k = Blockly.JavaScript.xcasVars.indexOf(varName);
	ind = Blockly.JavaScript.xcasIndices[k] + 1;
	Blockly.JavaScript.xcasIndices[k] = ind;
	nom = varName.substring(1)+ind;
	// on écrit la formule
	grille_set_formule(nom,leg);
}
function recuperer_valeur(varName) {
	try {
		var k = Blockly.JavaScript.xcasVars.indexOf(varName);
		var ind = Blockly.JavaScript.xcasIndices[k];
		return grille_get(ind,k);
	} catch (e) {
		return 0;
	}
}

function interpreter_affectation(varName, expression) {
  if (Blockly.JavaScript.xcasVars.includes(varName)) {
    var leg = expression;
	leg = leg.split("'").join("");
	leg = leg.split("\"").join("");
	leg = leg.split("Math.E").join("exp(1)");
	leg = leg.split("Math.SQRT2").join("sqrt(2)");
	leg = leg.split("Math.SQRT1_2").join("sqrt(1/2)");
	leg = leg.split("Math.").join("");
	var res = "set_formule('" + varName + "', '" + leg + "'); ";
	res += varName + "=" + "recuperer_valeur('" + varName + "'); ";
    return res + "\n";
  }  
  return varName + ' = ' + expression + ';\n';
}

Blockly.JavaScript['variables_set'] = function(block) {
  // Variable setter.
  var argument0 = Blockly.JavaScript.valueToCode(block, 'VALUE',
      Blockly.JavaScript.ORDER_ASSIGNMENT) || '0';
  var varName = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return interpreter_affectation(varName, argument0);
};

Blockly.JavaScript['sophus_carre'] = function(block) {
  var varName = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return interpreter_affectation(varName, varName + ' * ' + varName);
};

Blockly.JavaScript['sophus_doubler'] = function(block) {
  var varName = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  var choix = block.getFieldValue('CHOIX');
  return interpreter_affectation(varName, varName + ' * ' + choix);
};

Blockly.JavaScript['sophus_augmenter'] = function(block) {
  var argument0 = Blockly.JavaScript.valueToCode(block, 'DELTA',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  var varName = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return interpreter_affectation(varName, varName + ' + ' + argument0);
};

Blockly.JavaScript['sophus_diminuer'] = function(block) {
  var argument0 = Blockly.JavaScript.valueToCode(block, 'DELTA',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  var varName = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return interpreter_affectation(varName, varName + ' - ' + argument0);
};

Blockly.JavaScript['sophus_multiplier'] = function(block) {
  var argument0 = Blockly.JavaScript.valueToCode(block, 'DELTA',
      Blockly.JavaScript.ORDER_ADDITION) || '1';
  var varName = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return interpreter_affectation(varName, varName + ' * ' + argument0);
};

Blockly.JavaScript['sophus_diviser'] = function(block) {
  var argument0 = Blockly.JavaScript.valueToCode(block, 'DELTA',
      Blockly.JavaScript.ORDER_ADDITION) || '1';
  var varName = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return interpreter_affectation(varName, varName + ' / ' + argument0);
};

Blockly.JavaScript['sophus_augmenter_pct'] = function(block) {
  var argument0 = Blockly.JavaScript.valueToCode(block, 'DELTA',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  var varName = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return interpreter_affectation(varName, varName + ' * (1 + ' + argument0 + ' / 100)');
};

Blockly.JavaScript['sophus_diminuer_pct'] = function(block) {
  var argument0 = Blockly.JavaScript.valueToCode(block, 'DELTA',
      Blockly.JavaScript.ORDER_ADDITION) || '0';
  var varName = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return interpreter_affectation(varName, varName + ' * (1 - ' + argument0 + ' / 100)');
};

Blockly.JavaScript['sophus_inverser'] = function(block) {
  var varName = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return interpreter_affectation(varName, varName + '1 / ' + varName);
};

Blockly.JavaScript['sophus_puissance'] = function(block) {
  var argument0 = Blockly.JavaScript.valueToCode(block, 'POW',
      Blockly.JavaScript.ORDER_ADDITION) || '1';
  var varName = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  return interpreter_affectation(varName, 'Math.pow(' + varName + ' , ' + argument0 + ')');
};

// ameliore la traduction quand la borne sup d'un Pour est une variable
// gere les indices _A, _B ... _O
Blockly.JavaScript['controls_for'] = function(block) {
  // For loop.
  var variable0 = Blockly.JavaScript.variableDB_.getName(
      block.getFieldValue('VAR'), Blockly.Variables.NAME_TYPE);
  var argument0 = Blockly.JavaScript.valueToCode(block, 'FROM',
      Blockly.JavaScript.ORDER_ASSIGNMENT) || '0';
  var argument1 = Blockly.JavaScript.valueToCode(block, 'TO',
      Blockly.JavaScript.ORDER_ASSIGNMENT) || '0';
  var increment = Blockly.JavaScript.valueToCode(block, 'BY',
      Blockly.JavaScript.ORDER_ASSIGNMENT) || '1';
  var branch = Blockly.JavaScript.statementToCode(block, 'DO');
  branch = Blockly.JavaScript.addLoopTrap(branch, block.id);
  var code = "";
  if (Blockly.JavaScript.xcasVars.includes(variable0)) {
	code += "set_formule('" + variable0 + "', '" + argument0 + "'); \n";
	branch += "set_formule('" + variable0 + "', '" + variable0 + "+" + increment + "'); \n";
  }
  if (Blockly.isNumber(increment)) {
    // All arguments are simple numbers.
    var up = parseFloat(increment) >= 0;
    code += 'for (' + variable0 + ' = ' + argument0 + '; ' +
        variable0 + (up ? ' <= ' : ' >= ') + argument1 + '; ' +
        variable0;
    var step = Math.abs(parseFloat(increment));
    if (step == 1) {
      code += up ? '++' : '--';
    } else {
      code += (up ? ' += ' : ' -= ') + step;
    }
  } else {
    var up = true;
    code += 'for (' + variable0 + ' = ' + argument0 + '; ' +
        variable0 + (up ? ' <= ' : ' >= ') + argument1 + '; ' +
        variable0;
    code += (up ? ' += ' : ' -= ') + increment;
  }
  code += ') {\n' + branch + '}\n';
  return code;
};
